<?php

// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ) exit;

//if ( !class_exists('WPsite_Flyout_Fire_Admin_Functions') ) :

// AJAX call for laoding stats and email data

add_action( 'wp_ajax_wps_ff_stats_load', 					array('WPsite_Flyout_Fire_Admin_Functions', 'stats_load'));
add_action( 'wp_ajax_wps_ff_emails_load', 					array('WPsite_Flyout_Fire_Admin_Functions', 'emails_load'));
add_action( 'wp_ajax_wps_ff_entries_load', 					array('WPsite_Flyout_Fire_Admin_Functions', 'entries_load'));
add_action( 'wp_ajax_wps_ff_entry_load', 					array('WPsite_Flyout_Fire_Admin_Functions', 'entry_load'));

// AJAX call to get all tags and custom posts

add_action( 'wp_ajax_wps_ff_get_categories', 				array('WPsite_Flyout_Fire_Admin_Functions', 'get_categories'));
add_action( 'wp_ajax_wps_ff_get_tags', 						array('WPsite_Flyout_Fire_Admin_Functions', 'get_tags'));
add_action( 'wp_ajax_wps_ff_get_posts', 					array('WPsite_Flyout_Fire_Admin_Functions', 'get_posts'));

// AJAX call for loading MailChimp and Aweber List Data

add_action( 'wp_ajax_wps_ff_get_mailchimp_lists', 			array('WPsite_Flyout_Fire_Admin_Functions', 'get_mailchimp_lists'));
add_action( 'wp_ajax_wps_ff_get_aweber_lists', 				array('WPsite_Flyout_Fire_Admin_Functions', 'get_aweber_lists'));
add_action( 'wp_ajax_wps_ff_get_getresponse_lists', 		array('WPsite_Flyout_Fire_Admin_Functions', 'get_getresponse_lists'));
add_action( 'wp_ajax_wps_ff_get_campaignmonitor_lists', 	array('WPsite_Flyout_Fire_Admin_Functions', 'get_campaignmonitor_lists'));
add_action( 'wp_ajax_wps_ff_update_campaignmonitor_lists', 	array('WPsite_Flyout_Fire_Admin_Functions', 'update_campaignmonitor_lists'));
add_action( 'wp_ajax_wps_ff_get_madmimi_lists', 			array('WPsite_Flyout_Fire_Admin_Functions', 'get_madmimi_lists'));
add_action( 'wp_ajax_wps_ff_get_infusionsoft_lists', 		array('WPsite_Flyout_Fire_Admin_Functions', 'get_infusionsoft_lists'));
add_action( 'wp_ajax_wps_ff_get_mymail_lists', 				array('WPsite_Flyout_Fire_Admin_Functions', 'get_mymail_lists'));
add_action( 'wp_ajax_wps_ff_get_activecampaign_lists', 		array('WPsite_Flyout_Fire_Admin_Functions', 'get_activecampaign_lists'));

// Cron Jobs

add_action( 'initialize_flyout_fire_stats_daily_cron', 		array('WPsite_Flyout_Fire_Admin_Functions', 'initialize_flyout_fire_stats_daily'), 10 ,2 );
add_action( 'setup_flyout_fire_email_stats_cron', 			array('WPsite_Flyout_Fire_Admin_Functions', 'setup_flyout_fire_email_stats'), 10 ,2 );

// Miscellaneous

add_action( 'wp_ajax_wps_ff_send_weekly_email', 			array('WPsite_Flyout_Fire_Admin_Functions', 'send_weekly_email'));

/**
 *
 * Main class for all admin functions
 *
 * @since 1.2.5
 */
class WPsite_Flyout_Fire_Admin_Functions {

	/**
	 * Returns a default Flyout
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function default_flyout_fire(){
		return array(
			'id' 			=> '',
			'name' 			=> '',
			'text'			=> __('Join our community to get our latest news and updates.', WPsite_Flyout_Fire::$text_domain),
			'template' 		=> 'newsletter',
			'location' 		=> '9',
			'display' 		=> 'Bar',
			'color' 		=> '#ffffff',
			'text_color' 	=> '#333333',
			'trigger' 		=> array(
				'type'		=> 'site',
				'args'		=> array(
					'type'			=> 'timer',
					'timer' 		=> '0',
					'scroll' 		=> '75',
					'users'			=> 'any',
					'user_roles'	=> array(),
					'referrer_type'	=> 'any',
					'referrer'		=> 't.co,www.facebook.com,plus.url.google.com,www.linkedin.com',
				),
			),
			'link_url' 		=> 'http://wpsite.net',
			'link_name' 	=> __('Click Here!', WPsite_Flyout_Fire::$text_domain),
			'text_link' 	=> array(
				'link_type'			=> 'button',
				'link_target'		=> '_blank',
				'link_rel'			=> '',
				'link_text_color'	=> '#ffffff',
				'link_button_color'	=> '#ef5f00',
				'display_button'	=> 'yes',
			),
			'social' => array(
				'link_type'		=> 'flat',
				'icons'			=> array(
					array('type' => 'fa-facebook', 'url' => 'https://www.facebook.com/WPsite'),
					array('type' => 'fa-google-plus', 'url' => 'https://plus.google.com/106771475441130344412/posts'),
					array('type' => 'fa-twitter', 'url' => 'https://twitter.com/WPsite'),
					array('type' => 'fa-linkedin', 'url' => 'http://linkedin.com/company/wpsite'),
					array('type' => 'fa-youtube', 'url' => 'http://youtube.com/wpsitenet/'),
					array('type' => 'fa-reddit', 'url' => 'http://reddit.com/u/wpsite'),
					array('type' => 'fa-instagram', 'url' => 'http://instagram.com/wpsite'),
					array('type' => 'fa-pinterest', 'url' => 'http://pinterest.com/wpsite/'),
				),
			),
			'news_letter' => array(
				'type' 						=> 'WordPress',
				'first_name_placeholder'	=> __('First Name', WPsite_Flyout_Fire::$text_domain),
				'last_name_placeholder'		=> __('Last Name', WPsite_Flyout_Fire::$text_domain),
				'email_placeholder'			=> __('Email', WPsite_Flyout_Fire::$text_domain),
				'first_name'				=> true,
				'last_name'					=> true,
				'button_text'				=> __('Subscribe', WPsite_Flyout_Fire::$text_domain),
				'success_action'			=> 'message',
				'success_message'			=> __('We will be in touch soon!', WPsite_Flyout_Fire::$text_domain),
				'success_url'		=> '',
				'MailChimp' 	=> array(
					'url' 		=> '',
					'api_key'	=> '',
					'list'		=> '',
					'optin'		=> true,
				),
				'aweber' => array(
					'consumer_key' 		=> '',
					'consumer_secret' 	=> '',
					'access_key' 		=> '',
					'access_secret' 	=> '',
					'account_id' 		=> '',
					'list_id' 			=> ''
				),
				'getresponse'	=> array(
					'api_key' 		=> '',
					'campaign'		=> '',
				),
				'campaignmonitor'	=> array(
					'api_key'			=> '',
					'client' 			=> '',
					'list'				=> '',
				),
				'madmimi'	=> array(
					'api_key'			=> '',
					'username' 			=> '',
					'list'				=> '',
				),
				'infusionsoft'	=> array(
					'app_id'			=> '',
					'api_key' 			=> '',
					'list'				=> '',
				),
				'mymail' 	=> array(
					'list'		=> '',
				),
				'activecampaign' 	=> array(
					'api_url'	=> '',
					'api_key'	=> '',
					'list'		=> '',
				),
				'feedburner' => array(
					'id'	=> ''
				)
			),
			'custom' 	=> '',
			'active' 	=> 'Active',
			'animation'	=> 'yes',
			'args'		=> array(
				'recent_posts'		=> array(
					'tag'			=> '',
					'count'			=> '3',
				),
				'related_posts'  	=> array(
					'count'			=> '3',
				),
				'twitter'			=> array(
					'count'			=> '3',
					'api_key'		=> '',
					'api_secret'	=> '',
					'token'			=> '',
					'token_secret'	=> '',
				),
				'contact_location'  => array(
					'name'				=> __('My Business Name', WPsite_Flyout_Fire::$text_domain),
					'street'			=> '123 My Road',
					'city'				=> 'City',
					'state'				=> 'State',
					'zip'				=> '12345',
					'country'			=> 'Country',
					'phone'				=> '+1 (123) 456 - 7890',
					'email'				=> 'email@example.com',
				),
				'contact_us'  => array(
					'email'			=> get_bloginfo('admin_email'),
					'email_placeholder'			=> __('Email', WPsite_Flyout_Fire::$text_domain),
					'subject_placeholder'		=> __('Subject', WPsite_Flyout_Fire::$text_domain),
					'message_placeholder'		=> __('Message', WPsite_Flyout_Fire::$text_domain),
					'button_text'				=> __('Contact Us', WPsite_Flyout_Fire::$text_domain),
				),
				'list'					=>  array(
					'color'			=> '#000000',
					'items'			=> array(
						array('icon' => 'fa-envelope', 'text' => __('Increase signups', WPsite_Flyout_Fire::$text_domain)),
						array('icon' => 'fa-line-chart', 'text' => __('Drive more traffic', WPsite_Flyout_Fire::$text_domain)),
						array('icon' => 'fa-crosshairs', 'text' => __('Create targeted call to action', WPsite_Flyout_Fire::$text_domain)),
						array('icon' => 'fa-comment-o', 'text' => __('Display the right message at the right time', WPsite_Flyout_Fire::$text_domain)),
						array('icon' => 'fa-group', 'text' => __('Show your content to the correct audience', WPsite_Flyout_Fire::$text_domain)),
					),
				),
				'post'		=> array(
					'thumbnail'	=> 'yes',
					'meta_data'	=> 'yes',
					'excerpt'	=> 'no'
				),
				'heading'				=> __('Signup Now', WPsite_Flyout_Fire::$text_domain),
				'background_type'		=> 'pattern',
				'background_image'		=> '',
				'background_pattern'	=> 'none',
				'size'					=> 'medium',
				'shape'					=> 'square',
				'stub_location'			=> 'right',
				'stub_shape'			=> 'drop',
				'link_color'			=> '#ef5f00',
				'icon_color'			=> '#000000',
				'border_color'			=> '#ef5f00',
				'position'				=> 'fixed',
				'slide_direction'		=> 'up',
				'effect'				=> 'slide',
				'border_size'			=> '0',
				'start_date'			=> null,
				'end_date'				=> null,
				'mobile'				=> 'yes',
				'text_align'			=> 'center',
				'link_decoration'		=> 'none',
				'font_size'				=> '15',
				'font_weight'			=> 'normal',
				'font_family'			=> 'Arial, Helvetica, sans-serif',
				'heading_font_family'	=> 'Arial, Helvetica, sans-serif',
				'google_fonts'			=> false,
				'heading_google_fonts'	=> false,
				'close_button'   		=> true,
				'dont_show_again'		=> true,
				'icon'					=> 'fa-fire',
				'nl_text_color'			=> '#ffffff',
				'nl_button_color'		=> '#ef5f00',
				'subscribe_icon'		=> 'fa-envelope',
				'subscribe_icon_place'	=> 'before',
				'social_color'			=> '#4FC000',
				'shadow'				=> 'no',
				'push_pull'				=> 'no',
				'full'					=> 'no',
				'powered_by'			=> 'yes',
				'footer'				=> __('We promise never to spam or share your information.', WPsite_Flyout_Fire::$text_domain),
				'footer_icon'			=> 'fa-lock',
			)
		);
	}

	/**
	 * Default settings for all optin fires
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function default_global_settings() {
		return array(
			'send_weekly_email'	=> true,
		);
	}

	/**
	 * Parse all the data and get it ready to be saved
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function save_data() {

		// Get all post types

		$post_types = get_post_types(array('public' => true));
		global $wp_roles;

		$default_flyout_fire = self::default_flyout_fire();

		$val['name']                              = stripslashes(sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'name']));

		$val['args']['heading']                   = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'heading']) ?
													stripslashes(sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'heading'])) :
													$default_flyout_fire['args']['heading'];

		$val['text']                              = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'text']) ?
													stripslashes(sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'text'])) :
													$default_flyout_fire['text'];

		$val['template']                          = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'template']) ?
													$_POST[WPsite_Flyout_Fire::$prefix_dash . 'template'] :
													$default_flyout_fire['template'];

		$val['location']                          = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'location']) ?
													$_POST[WPsite_Flyout_Fire::$prefix_dash . 'location'] :
													$default_flyout_fire['location'];

		$val['display']                           = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'display']) ?
													$_POST[WPsite_Flyout_Fire::$prefix_dash . 'display'] :
													$default_flyout_fire['display'];

		$val['color']                             = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'color']) ?
													sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'color']) :
													$default_flyout_fire['color'];

		$val['text_color']                        = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'text-color']) ?
													sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'text-color']) :
													$default_flyout_fire['text_color'];

		$val['active']                            = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'active']) ?
													$_POST[WPsite_Flyout_Fire::$prefix_dash . 'active'] :
													$default_flyout_fire['active'];

		$val['animation']                         = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'animation']) &&
													$_POST[WPsite_Flyout_Fire::$prefix_dash . 'animation'] ? 'yes' : 'no';

		// Args

		$val['args']['background_type']           = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'background-type']) ?
													sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'background-type']) :
													$default_flyout_fire['args']['background_type'];

		$val['args']['background_image']          = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'background-image']) ?
													sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'background-image']) :
													$default_flyout_fire['args']['background_image'];

		$val['args']['background_pattern']        = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'background-pattern']) ?
													sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'background-pattern']) :
													$default_flyout_fire['args']['background_pattern'];

		$val['args']['size']                      = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'size']) ?
													$_POST[WPsite_Flyout_Fire::$prefix_dash . 'size'] :
													$default_flyout_fire['size'];

		$val['args']['shape']                     = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'shape']) ?
													$_POST[WPsite_Flyout_Fire::$prefix_dash . 'shape'] :
													$default_flyout_fire['shape'];

		$val['args']['stub_location']             = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'stub-location']) ?
													$_POST[WPsite_Flyout_Fire::$prefix_dash . 'stub-location'] :
													$default_flyout_fire['stub_location'];

		$val['args']['stub_shape']                = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'stub-shape']) ?
													$_POST[WPsite_Flyout_Fire::$prefix_dash . 'stub-shape'] :
													$default_flyout_fire['stub_shape'];

		$val['args']['link_color']                = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'link-color']) ?
													sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'link-color']) :
													$default_flyout_fire['args']['link_color'];

		$val['args']['icon_color']                = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'icon-color']) ?
													sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'icon-color']) :
													$default_flyout_fire['args']['icon_color'];

		$val['args']['border_color']              = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'border-color']) ?
													sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'border-color']) :
													$default_flyout_fire['args']['border_color'];

		$val['args']['position']                  = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'position']) ?
													$_POST[WPsite_Flyout_Fire::$prefix_dash . 'position'] :
													$default_flyout_fire['args']['position'];

		$val['args']['slide_direction']           = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'slide-direction']) ?
													$_POST[WPsite_Flyout_Fire::$prefix_dash . 'slide-direction'] :
													$default_flyout_fire['args']['slide_direction'];

		$val['args']['effect']                    = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'effect']) ?
													$_POST[WPsite_Flyout_Fire::$prefix_dash . 'effect'] :
													$default_flyout_fire['args']['effect'];

		$val['args']['border_size']               = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'border-size']) ?
													sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'border-size']) :
													$default_flyout_fire['args']['border_size'];

		$val['args']['mobile']                    = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'mobile']) &&
													$_POST[WPsite_Flyout_Fire::$prefix_dash . 'mobile'] ? 'yes' : 'no';

		$val['args']['text_align']                = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'text-align']) ?
													sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'text-align']) :
													$default_flyout_fire['args']['text_align'];

		$val['args']['link_decoration']           = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'link-decoration']) ?
													sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'link-decoration']) :
													$default_flyout_fire['args']['link_decoration'];

		$val['args']['font_size']                 = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'font-size']) ?
													sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'font-size']) :
													$default_flyout_fire['args']['font_size'];

		$val['args']['font_weight']               = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'font-weight']) ?
													sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'font-weight']) :
													$default_flyout_fire['args']['font_weight'];

		$val['args']['heading_font_family']       = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'heading-font-family']) ?
													sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'heading-font-family']) :
													$default_flyout_fire['args']['heading_font_family'];

		$val['args']['heading_google_fonts']      = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'heading-google-fonts']) &&
													$_POST[WPsite_Flyout_Fire::$prefix_dash . 'heading-google-fonts'] ? true : false;

		$val['args']['font_family']               = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'font-family']) ?
													sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'font-family']) :
													$default_flyout_fire['args']['font_family'];

		$val['args']['google_fonts']              = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'google-fonts']) &&
													$_POST[WPsite_Flyout_Fire::$prefix_dash . 'google-fonts'] ? true : false;

		$val['args']['close_button']      		  = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'close-button']) &&
													$_POST[WPsite_Flyout_Fire::$prefix_dash . 'close-button'] ? true : false;

		$val['args']['dont_show_again']      		  = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'dont-show-again']) &&
													$_POST[WPsite_Flyout_Fire::$prefix_dash . 'dont-show-again'] ? true : false;

		$val['args']['start_date']                = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'start-date']) ?
													sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'start-date']) :
													date("m/d/Y");

		$val['args']['end_date']                  = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'end-date']) ?
													sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'end-date']) :
													date("m/d/Y", mktime(0, 0, 0, date("m"), date("d"), date("Y")+20));

		$val['args']['icon']                      = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'icon']) ?
													sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'icon']) :
													$default_flyout_fire['args']['icon'];

		$val['args']['nl_text_color']             = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'newsletter-text-color']) ?
													sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'newsletter-text-color']) :
													$default_flyout_fire['args']['nl_text_color'];

		$val['args']['nl_button_color']           = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'newsletter-button-color']) ?
													sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'newsletter-button-color']) :
													$default_flyout_fire['args']['nl_button_color'];

		$val['args']['subscribe_icon']            = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'subscribe-icon']) ?
													$_POST[WPsite_Flyout_Fire::$prefix_dash . 'subscribe-icon'] :
													$default_flyout_fire['args']['subscribe_icon'];

		$val['args']['subscribe_icon_place']      = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'subscribe-icon-place']) ?
													$_POST[WPsite_Flyout_Fire::$prefix_dash . 'subscribe-icon-place'] :
													$default_flyout_fire['args']['subscribe_icon_place'];

		$val['args']['social_color']              = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'social-color']) ?
													sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'social-color']) :
													$default_flyout_fire['args']['social_color'];

		$val['args']['shadow']                    = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'shadow']) &&
													$_POST[WPsite_Flyout_Fire::$prefix_dash . 'shadow'] ? 'yes' : 'no';

		$val['args']['push_pull']                 = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'push-pull']) &&
													$_POST[WPsite_Flyout_Fire::$prefix_dash . 'push-pull'] ? 'yes' : 'no';

		$val['args']['full']                      = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'full']) ?
													$_POST[WPsite_Flyout_Fire::$prefix_dash . 'full'] :
													$default_flyout_fire['args']['full'];

		$val['args']['powered_by']                = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'powered-by']) &&
													$_POST[WPsite_Flyout_Fire::$prefix_dash . 'powered-by'] ? 'yes' : 'no';

		$val['args']['footer']                    = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'footer']) ?
													stripcslashes($_POST[WPsite_Flyout_Fire::$prefix_dash . 'footer']) : $default_flyout_fire['args']['footer'];

		$val['args']['footer_icon']               = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'footer-icon']) ?
													$_POST[WPsite_Flyout_Fire::$prefix_dash . 'footer-icon'] :
													$default_flyout_fire['args']['footer_icon'];


		// Recent Posts

		$val['args']['recent_posts']['tag']           = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'recent-posts-tag']) ?
														sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'recent-posts-tag']) : '';

		$val['args']['recent_posts']['count']         = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'recent-posts-count']) ?
														sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'recent-posts-count']) : '5';

		// Related Posts

		$val['args']['related_posts']['count']        = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'related-posts-count']) ?
														sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'related-posts-count']) : '5';

		// Post Data

		$val['args']['post']['thumbnail']             = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'thumbnail']) &&
														$_POST[WPsite_Flyout_Fire::$prefix_dash . 'thumbnail'] ? 'yes' : 'no';

		$val['args']['post']['meta_data']             = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'meta-data']) &&
														$_POST[WPsite_Flyout_Fire::$prefix_dash . 'meta-data'] ? 'yes' : 'no';

		$val['args']['post']['excerpt']               = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'excerpt']) &&
														$_POST[WPsite_Flyout_Fire::$prefix_dash . 'excerpt'] ? 'yes' : 'no';

		// Contact / Location Info

		$val['args']['contact_location']['phone']     = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'contact-location-phone']) ?
														sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'contact-location-phone']) :
														$default_flyout_fire['args']['contact_location']['phone'];

		$val['args']['contact_location']['email']     = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'contact-location-email']) ?
														sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'contact-location-email']) :
														$default_flyout_fire['args']['contact_location']['email'];

		$val['args']['contact_location']['name']      = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'contact-location-name']) ?
														sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'contact-location-name']) :
														$default_flyout_fire['args']['contact_location']['name'];

		$val['args']['contact_location']['street']    = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'contact-location-street']) ?
														sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'contact-location-street']) :
														$default_flyout_fire['args']['contact_location']['street'];

		$val['args']['contact_location']['city']      = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'contact-location-city']) ?
														sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'contact-location-city']) :
														$default_flyout_fire['args']['contact_location']['city'];

		$val['args']['contact_location']['zip']       = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'contact-location-zip']) ?
														sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'contact-location-zip']) :
														$default_flyout_fire['args']['contact_location']['zip'];

		$val['args']['contact_location']['state']     = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'contact-location-state']) ?
														sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'contact-location-state']) :
														$default_flyout_fire['args']['contact_location']['state'];

		$val['args']['contact_location']['country']   = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'contact-location-country']) ?
														sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'contact-location-country']) :
														$default_flyout_fire['args']['contact_location']['country'];


		// Contact Us

		$val['args']['contact_us']['email']           	  = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'contact-us-email']) ?
															sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'contact-us-email']) : '';

		$val['args']['contact_us']['email_placeholder']   = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'contact-us-email-placeholder']) ?
															stripcslashes(sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'contact-us-email-placeholder'])) :
															$default_flyout_fire['template']['args']['contact_us']['email_placeholder'];

		$val['args']['contact_us']['subject_placeholder'] = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'contact-us-subject-placeholder']) ?
															stripcslashes(sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'contact-us-subject-placeholder'])) :
															$default_flyout_fire['template']['args']['contact_us']['subject_placeholder'];

		$val['args']['contact_us']['message_placeholder'] = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'contact-us-message-placeholder']) ?
															stripcslashes(sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'contact-us-message-placeholder'])) :
															$default_flyout_fire['template']['args']['contact_us']['message_placeholder'];

		$val['args']['contact_us']['button_text']         = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'contact-us-button-text']) ?
															stripcslashes(sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'contact-us-button-text'])) :
															$default_flyout_fire['template']['args']['contact_us']['button_text'];

		// Twitter Feed

		$val['args']['twitter']['count']              = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'twitter-count']) ?
														sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'twitter-count']) : '5';

		$val['args']['twitter']['api_key']            = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'twitter-api-key']) ?
														sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'twitter-api-key']) : '';

		$val['args']['twitter']['api_secret']         = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'twitter-api-secret']) ?
														sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'twitter-api-secret']) : '';

		$val['args']['twitter']['token']              = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'twitter-token']) ?
														sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'twitter-token']) : '';

		$val['args']['twitter']['token_secret']       = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'twitter-token-secret']) ?
									sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'twitter-token-secret']) : '';

		// Trigger

		$val['trigger']['type']                       = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'trigger-type']) ?
														$_POST[WPsite_Flyout_Fire::$prefix_dash . 'trigger-type'] :
														$default_flyout_fire['trigger']['type'];

		$val['trigger']['category']['all']            = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'trigger-category-all']) ?
														$_POST[WPsite_Flyout_Fire::$prefix_dash . 'trigger-category-all'] : false;

		$val['trigger']['category']['id']             = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'trigger-category-id']) ?
														sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'trigger-category-id']) : '';

		$val['trigger']['tag']['id']                  = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'trigger-tag-id']) ?
														sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'trigger-tag-id']) : '';

		foreach ($post_types as $post_type) {
			$val['trigger'][$post_type]['all']        = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'trigger-all-' . $post_type]) ?
														$_POST[WPsite_Flyout_Fire::$prefix_dash . 'trigger-all-' . $post_type] : false;

			$val['trigger'][$post_type]['id']         = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'trigger-id-' . $post_type]) ?
														sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'trigger-id-' . $post_type]) : false;
		}

		$val['trigger']['args']['type']               = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'trigger-args-type']) ?
														$_POST[WPsite_Flyout_Fire::$prefix_dash . 'trigger-args-type'] :
														$default_flyout_fire['trigger']['args']['type'];

		$val['trigger']['args']['timer']              = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'trigger-args-timer']) ?
														sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'trigger-args-timer']) :
														$default_flyout_fire['trigger']['args']['timer'];

		$val['trigger']['args']['scroll']             = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'trigger-args-scroll']) ?
														sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'trigger-args-scroll']) :
														$default_flyout_fire['trigger']['args']['scroll'];

		$val['trigger']['args']['user_roles']         = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'trigger-args-user-roles']) ?
														sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'trigger-args-user-roles']) :
														$default_flyout_fire['trigger']['args']['user_roles'];

		$val['trigger']['args']['category']['all']    = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'trigger-args-category-all']) ?
														$_POST[WPsite_Flyout_Fire::$prefix_dash . 'trigger-args-category-all'] : '';

		$val['trigger']['args']['category']['id']     = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'trigger-args-category-id']) ?
														sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'trigger-args-category-id']) : '';

		$val['trigger']['args']['tag']['id']          = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'trigger-args-tag-id']) ?
														sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'trigger-args-tag-id']) : '';

		$val['trigger']['args']['users']              = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'trigger-args-users']) ?
														sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'trigger-args-users']) :
														$default_flyout_fire['trigger']['args']['users'];

		// User roles

		foreach ($wp_roles->role_names as $role_name  => $role) {
			$val['trigger']['args']['user_roles'][$role_name] = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'role-args-' . $role_name]) &&
																$_POST[WPsite_Flyout_Fire::$prefix_dash . 'role-args-' . $role_name] ? true : false;
		}

		$val['trigger']['args']['referrer_type']              = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'trigger-args-referrer-type']) ?
																$_POST[WPsite_Flyout_Fire::$prefix_dash . 'trigger-args-referrer-type'] :
																$default_flyout_fire['trigger']['args']['referrer_type'];

		$val['trigger']['args']['referrer']                   = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'trigger-args-referrer']) ?
																$_POST[WPsite_Flyout_Fire::$prefix_dash . 'trigger-args-referrer'] :
																$default_flyout_fire['trigger']['args']['referrer'];

		// Check if no domains were added

		if ( $val['trigger']['args']['referrer_type'] == 'specific' && $val['trigger']['args']['referrer'] == '' ) {
			$val['trigger']['args']['referrer_type'] = 'any';
		}

		// Text and Link

		$val['link_url']                                      = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'link-url']) ?
																sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'link-url']) :
																$default_flyout_fire['link_url'];

		$val['link_name']                                     = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'link-name']) ?
																stripslashes(sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'link-name'])) :
																$default_flyout_fire['link_name'];

		$val['text_link']['link_type']                        = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'link-type']) ?
																sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'link-type']) :
																$default_flyout_fire['text_link']['link_type'];

		$val['text_link']['link_target']                      = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'link-target']) ?
																sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'link-target']) :
																$default_flyout_fire['text_link']['link_target'];

		$val['text_link']['link_rel']                         = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'link-rel']) ?
																sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'link-rel']) :
																$default_flyout_fire['text_link']['link_rel'];

		$val['text_link']['link_text_color']                  = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'link-text-color']) ?
																sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'link-text-color']) :
																$default_flyout_fire['text_link']['link_text_color'];

		$val['text_link']['link_button_color']                = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'link-button-color']) ?
																sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'link-button-color']) :
																$default_flyout_fire['text_link']['link_button_color'];

		$val['text_link']['display_button']                   = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'display-button']) &&
																$_POST[WPsite_Flyout_Fire::$prefix_dash . 'display-button'] ? 'yes' : 'no';

		// Social

		$val['social']['link_type']	  = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'social-link-type']) ?
										sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'social-link-type']) :
										$default_flyout_fire['social']['link_type'];

		$social_type              	  = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'social-type']) ?
										$_POST[WPsite_Flyout_Fire::$prefix_dash . 'social-type'] : '';

		$social_url               	  = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'social-url']) ?
										$_POST[WPsite_Flyout_Fire::$prefix_dash . 'social-url'] : '';

		$social_media_icons = array();

		for ($i = 0; $i < count($social_type); $i++) {

			if (isset($social_type[$i]) && $social_type[$i] != '' && $social_url[$i] != '') {
				$social_media_icons[] = array(
					'type' 	=> sanitize_text_field($social_type[$i]),
					'url' 	=> sanitize_text_field($social_url[$i])
				);
			}
		}

		$val['social']['icons'] = $social_media_icons;

		// List Items

		$val['args']['list']['color'] = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'list-color']) ?
										sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'list-color']) :
										$default_flyout_fire['args']['list']['color'];

		$list_text 					  = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'list-text']) ?
										$_POST[WPsite_Flyout_Fire::$prefix_dash . 'list-text'] : '';

		$list_icon 					  = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'list-icon']) ?
										$_POST[WPsite_Flyout_Fire::$prefix_dash . 'list-icon'] : '';

		$list_items = array();

		for ($i = 0; $i < count($list_text); $i++) {

			if (isset($list_text[$i]) && $list_text[$i] != '' && $list_icon[$i] != '') {
				$list_items[] = array(
					'icon' 	=> sanitize_text_field($list_icon[$i]),
					'text' 	=> stripcslashes(sanitize_text_field($list_text[$i]))
				);
			}
		}

		$val['args']['list']['items'] = $list_items;

		// News Letter

		$val['news_letter']['type']                               = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-type']) ?
																	$_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-type'] :
																	$default_flyout_fire['news_letter']['type'];

		$val['news_letter']['first_name']                         = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-first-name']) &&
																	$_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-first-name'] ? true : false;

		$val['news_letter']['last_name']                          = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-last-name']) &&
																	$_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-last-name'] ? true : false;

		$val['news_letter']['first_name_placeholder']             = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-first-name-placeholder']) ?
																	stripcslashes(sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-first-name-placeholder'])) :
																	$default_flyout_fire['news_letter']['first_name_placeholder'];

		$val['news_letter']['last_name_placeholder']              = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-last-name-placeholder']) ?
																	stripcslashes(sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-last-name-placeholder'])) :
																	$default_flyout_fire['news_letter']['last_name_placeholder'];

		$val['news_letter']['email_placeholder']                  = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-email-placeholder']) ?
																	stripcslashes(sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-email-placeholder'])) :
																	$default_flyout_fire['news_letter']['email_placeholder'];

		$val['news_letter']['success_action']            		  = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-success-action']) ?
																	$_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-success-action'] :
																	$default_popup['news_letter']['success_action'];

		$val['news_letter']['button_text']            		      = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-button-text']) ?
																	stripcslashes(sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-button-text'])) :
																	$default_popup['news_letter']['button_text'];

		$val['news_letter']['success_message']            		  = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-success-message']) ?
																	stripcslashes(sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-success-message'])) :
																	$default_popup['news_letter']['success_message'];

		$val['news_letter']['success_url']            		  	  = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-success-url']) ?
																	sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-success-url']) :
																	$default_popup['news_letter']['success_url'];

		// MailChimp

		$val['news_letter']['MailChimp']['url']                   = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-MailChimp-url']) ?
																	sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-MailChimp-url']) :
																	$default_flyout_fire['news_letter']['MailChimp']['url'];

		$val['news_letter']['MailChimp']['api_key']               = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-MailChimp-api-key']) ?
																	sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-MailChimp-api-key']) :
																	$default_flyout_fire['news_letter']['MailChimp']['api_key'];

		$val['news_letter']['MailChimp']['list']                  = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-MailChimp-list']) ?
																	sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-MailChimp-list']) :
																	$default_flyout_fire['news_letter']['MailChimp']['list'];

		$val['news_letter']['MailChimp']['optin']                  = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-MailChimp-optin']) &&
																	 $_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-MailChimp-optin'] ? true : false;

		// Aweber

		$val['news_letter']['aweber']['consumer_key']             = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-aweber-consumer-key']) ?
																	sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-aweber-consumer-key']) :
																	$default_flyout_fire['news_letter']['aweber']['consumer_key'];

		$val['news_letter']['aweber']['consumer_secret']          = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-aweber-consumer-secret']) ?
																	sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-aweber-consumer-secret']) :
																	$default_flyout_fire['news_letter']['aweber']['consumer_secret'];

		$val['news_letter']['aweber']['access_key']               = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-aweber-access-key']) ?
																	sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-aweber-access-key']) :
																	$default_flyout_fire['news_letter']['aweber']['access_key'];

		$val['news_letter']['aweber']['access_secret']            = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-aweber-access-secret']) ?
																	sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-aweber-access-secret']) :
																	$default_flyout_fire['news_letter']['aweber']['access_secret'];

		$val['news_letter']['aweber']['account_id']               = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-aweber-account-id']) ?
																	sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-aweber-account-id']) :
																	$default_flyout_fire['news_letter']['aweber']['account_id'];

		$val['news_letter']['aweber']['list_id']                  = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-aweber-list-id']) ?
																	sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-aweber-list-id']) :
																	$default_flyout_fire['news_letter']['aweber']['list_id'];

		// Get Response

		$val['news_letter']['getresponse']['api_key']             = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-getresponse-api-key']) ?
																	sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-getresponse-api-key']) :
																	$default_flyout_fire['news_letter']['getresponse']['api_key'];

		$val['news_letter']['getresponse']['campaign']            = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-getresponse-campaign']) ?
																	sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-getresponse-campaign']) :
																	$default_flyout_fire['news_letter']['getresponse']['campaign'];

		// Campiagn Monitor

		$val['news_letter']['campaignmonitor']['api_key']         = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-campaignmonitor-api-key']) ?
																	sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-campaignmonitor-api-key']) :
																	$default_flyout_fire['news_letter']['campaignmonitor']['api_key'];

		$val['news_letter']['campaignmonitor']['client']          = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-campaignmonitor-client']) ?
																	sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-campaignmonitor-client']) :
																	$default_flyout_fire['news_letter']['campaignmonitor']['client'];

		$val['news_letter']['campaignmonitor']['list']            = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-campaignmonitor-list']) ?
																	sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-campaignmonitor-list']) :
																	$default_flyout_fire['news_letter']['campaignmonitor']['list'];

		// Mad Mimi

		$val['news_letter']['madmimi']['api_key']                 = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-madmimi-api-key']) ?
																	sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-madmimi-api-key']) :
																	$default_flyout_fire['news_letter']['madmimi']['api_key'];

		$val['news_letter']['madmimi']['username']                = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-madmimi-username']) ?
																	sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-madmimi-username']) :
																	$default_flyout_fire['news_letter']['madmimi']['username'];

		$val['news_letter']['madmimi']['list']                    = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-madmimi-list']) ?
																	sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-madmimi-list']) :
																	$default_flyout_fire['news_letter']['madmimi']['list'];

		// Infusion Soft

		$val['news_letter']['infusionsoft']['app_id']             = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-infusionsoft-app-id']) ?
																	sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-infusionsoft-app-id']) :
																	$default_flyout_fire['news_letter']['infusionsoft']['app_id'];

		$val['news_letter']['infusionsoft']['api_key']            = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-infusionsoft-api-key']) ?
																	sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-infusionsoft-api-key']) :
																	$default_flyout_fire['news_letter']['infusionsoft']['api_key'];

		$val['news_letter']['infusionsoft']['list']               = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-infusionsoft-list']) ?
																	sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-infusionsoft-list']) :
																	$default_flyout_fire['news_letter']['infusionsoft']['list'];

		// MyMail

		$val['news_letter']['mymail']['list']                     = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-mymail-list']) ?
																	sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-mymail-list']) :
																	$default_flyout_fire['mymail']['list'];

		// Active Campaign

		$val['news_letter']['activecampaign']['app_url']          = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-activecampaign-app-url']) ?
																	sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-activecampaign-app-url']) :
																	$default_flyout_fire['news_letter']['activecampaign']['app_url'];

		$val['news_letter']['activecampaign']['api_key']          = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-activecampaign-api-key']) ?
																	sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-activecampaign-api-key']) :
																	$default_flyout_fire['news_letter']['activecampaign']['api_key'];

		$val['news_letter']['activecampaign']['list']             = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-activecampaign-list']) ?
																	sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-activecampaign-list']) :
																	$default_flyout_fire['news_letter']['activecampaign']['list'];

		// feedburner

		$val['news_letter']['feedburner']['id']                   = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-feedburner-id']) ?
																	sanitize_text_field($_POST[WPsite_Flyout_Fire::$prefix_dash . 'news-letter-feedburner-id']) :
																	$default_flyout_fire['aweber']['feedburner']['id'];

		// Custom

		$val['custom']                                            = isset($_POST[WPsite_Flyout_Fire::$prefix_dash . 'custom']) ?
																	stripcslashes($_POST[WPsite_Flyout_Fire::$prefix_dash . 'custom']) :
																	$default_flyout_fire['custom'];

		return $val;
	}

	/**
	 * Load all stats using ajax to make back-end more responsive
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function stats_load() {

		include_once(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . 'admin/model/db.php');
		include_once(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . 'core/model/stats.php');

		// Get Stats

		$start_date = date(WPSITE_FLYOUT_FIRE_DATE_FORMAT, mktime(0, 0, 0, date("m")-1, date("d"), date("Y")));
		$end_date = date(WPSITE_FLYOUT_FIRE_DATE_FORMAT, strtotime(current_time('mysql')));

		$post_start_date = urldecode($_POST['start_date']);
		$post_end_date = urldecode($_POST['end_date']);

		if (isset($post_start_date) && $post_start_date != '') {
			$start_date = date(WPSITE_FLYOUT_FIRE_DATE_FORMAT, strtotime($post_start_date));
		}

		if (isset($post_end_date) && $post_end_date != '') {
			$end_date = date(WPSITE_FLYOUT_FIRE_DATE_FORMAT, strtotime($post_end_date));
		}

		global $wpdb;

		// All flyout_fire stats

		if (isset($_POST['flyout_fire_name']) && $_POST['flyout_fire_name'] == '') {

			$stats = WPsite_Stats_FF::getStats($start_date, $end_date);

			$flyout_fires = $wpdb->get_results("SELECT * FROM `" . WPsite_Flyout_Fire_DB::getTableName() . "`");

			$flyout_fire_stats = array();

			foreach ($flyout_fires as $flyout_fire) {
				foreach ($stats as $stat) {
					if ($flyout_fire->id == $stat['flyout_fire_id']) {
						$flyout_fire_stats[$flyout_fire->id] = array(
							'flyout_fire_id'	=> $stat['flyout_fire_id'],
							'flyout_fire_name'	=> $flyout_fire->name,
							'flyout_fire_type'	=> $flyout_fire->template,
							'date'			=> $stat['date'],
							'impressions'	=> isset($flyout_fire_stats[$flyout_fire->id]['impressions']) ? $flyout_fire_stats[$flyout_fire->id]['impressions'] + $stat['impressions'] : $stat['impressions'],
							'clicks'	=> isset($flyout_fire_stats[$flyout_fire->id]['clicks']) ? $flyout_fire_stats[$flyout_fire->id]['clicks'] + $stat['clicks'] : $stat['clicks'],
						);
					}
				}
			}

			$impressions_total = 0;
			$conversions_total = 0;
			foreach ($flyout_fire_stats as $flyout_fire_stat) {
			    $impressions_total += $flyout_fire_stat['impressions'];
			    $conversions_total += $flyout_fire_stat['clicks'];
			}

			$ctr = $impressions_total != 0 ? round(($conversions_total/$impressions_total) * 100,2) : 0;

			$stats_content = '
			<div class="' . WPsite_Flyout_Fire::$prefix_dash . 'stats-total-container col-xs-12">
				<div class="' . WPsite_Flyout_Fire::$prefix_dash . 'stats-totals col-xs-4">
					<div class="'  . WPsite_Flyout_Fire::$prefix_dash . 'stats-impressions-total">
						<span>' . __('Impressions', WPsite_Flyout_Fire::$text_domain) . '</span>
						<div class="' . WPsite_Flyout_Fire::$prefix_dash . 'stats-totals-text">' . number_format($impressions_total) . '</div>
						<i class="fa fa-globe"></i>
					</div>
				</div>
				<div class="' . WPsite_Flyout_Fire::$prefix_dash . 'stats-totals col-xs-4">
					<div class="' . WPsite_Flyout_Fire::$prefix_dash . 'stats-conversions-total">
						<span>' . __('Conversions', WPsite_Flyout_Fire::$text_domain) . '</span>
						<div class="' . WPsite_Flyout_Fire::$prefix_dash . 'stats-totals-text">' . number_format($conversions_total) . '</div>
						<i class="fa fa-certificate"></i>
					</div>
				</div>
				<div class="' . WPsite_Flyout_Fire::$prefix_dash . 'stats-totals col-xs-4">
					<div class="' . WPsite_Flyout_Fire::$prefix_dash . 'stats-conversion-rate-total">
						<span>' .  __('Conversion Rate', WPsite_Flyout_Fire::$text_domain) . '</span>
						<div class="' . WPsite_Flyout_Fire::$prefix_dash . 'stats-totals-text">' . $ctr . '%</div>
						<i class="fa fa-usd"></i>
					</div>
				</div>
			</div>

			<div style="clear:both"></div>

			<div class="' . WPsite_Flyout_Fire::$prefix_dash . 'line-graph-container">
				<canvas id="' . WPsite_Flyout_Fire::$prefix_dash . 'line-graph"></canvas>
			</div>

			<div class="table-responsive">
				<table class="table table-condensed table-striped sortable">

					<thead>
						<th>' . __('Flyout', WPsite_Flyout_Fire::$text_domain) . '</th>
						<th class="' . WPsite_Flyout_Fire::$prefix_dash . 'impressions-key"><span class="glyphicon glyphicon-globe"></span> ' . __('Impressions', WPsite_Flyout_Fire::$text_domain) . '</th>
						<th class="' . WPsite_Flyout_Fire::$prefix_dash . 'conversions-key"><span class="glyphicon glyphicon-certificate"></span> ' . __('Conversions', WPsite_Flyout_Fire::$text_domain) . '</th>
						<th data-defaultsort="desc" class="' . WPsite_Flyout_Fire::$prefix_dash . 'conversion-rate-key"><i class="fa fa-usd"></i> ' . __('Conversion Rate', WPsite_Flyout_Fire::$text_domain) . '</th>
					</thead>';

					foreach ($flyout_fire_stats as $flyout_fire_stat) {

						$stats_content .= '<tr>
							<td>
								<a href="' . admin_url() . 'admin.php?page=' . WPsite_Flyout_Fire::$stats_page . '&flyout_fire_id=' . $flyout_fire_stat['flyout_fire_id'] . '&flyout_fire_name=' . $flyout_fire_stat['flyout_fire_name'] . '" role="button" class="btn btn-xs btn-primary">
									' .  $flyout_fire_stat['flyout_fire_name'] . '
								</a>
							</td>
							<td>' . number_format($flyout_fire_stat['impressions']) . '</td>';

							$stats_content .= '
							<td>' . number_format($flyout_fire_stat['clicks']) . '</td>
							<td>' . ($flyout_fire_stat['impressions'] > 0 ? round(($flyout_fire_stat['clicks'] / $flyout_fire_stat['impressions']) * 100, 2) : '0') . '%</td>';


						$stats_content .= '</tr>';
					}

				$stats_content .= '</table>
			</div>';
		}

		// Single flyout_fire stats

		else if (isset($_POST['flyout_fire_name']) && $_POST['flyout_fire_name'] != '') {

			$flyout_fire_stats = WPsite_Stats_FF::getStats($start_date, $end_date, $_POST['flyout_fire_id']);

			$flyout_fires = $wpdb->get_results("SELECT * FROM `" . WPsite_Flyout_Fire_DB::getTableName() . "`");

			foreach ($flyout_fires as $flyout_fire) {
				foreach ($flyout_fire_stats as $key => $flyout_fire_stat) {
					if ($flyout_fire->id == $flyout_fire_stat['flyout_fire_id']) {
						$flyout_fire_stats[$key] = array('flyout_fire_name' => $flyout_fire->name) + $flyout_fire_stats[$key] + array('flyout_fire_type' => $flyout_fire->template);
					}
				}
			}

			// Unset indexs

			foreach ($flyout_fire_stats as $key => $flyout_fire_stat) {
				unset($flyout_fire_stats[$key]['id']);
				unset($flyout_fire_stats[$key]['flyout_fire_id']);
			}

			$impressions_total = 0;
			$conversions_total = 0;
			foreach ($flyout_fire_stats as $flyout_fire_stat) {
			    $impressions_total += $flyout_fire_stat['impressions'];
			    $conversions_total += $flyout_fire_stat['clicks'];
			}

			$ctr = $impressions_total != 0 ? round(($conversions_total/$impressions_total) * 100,2) : 0;

			$stats_content = '
			<div class="' . WPsite_Flyout_Fire::$prefix_dash . 'stats-total-container col-xs-12">
				<div class="' . WPsite_Flyout_Fire::$prefix_dash . 'stats-totals col-xs-4">
					<div class="'  . WPsite_Flyout_Fire::$prefix_dash . 'stats-impressions-total">
						<span>' . __('Impressions', WPsite_Flyout_Fire::$text_domain) . '</span>
						<div class="' . WPsite_Flyout_Fire::$prefix_dash . 'stats-totals-text">' . number_format($impressions_total) . '</div>
						<i class="fa fa-globe"></i>
					</div>
				</div>
				<div class="' . WPsite_Flyout_Fire::$prefix_dash . 'stats-totals col-xs-4">
					<div class="' . WPsite_Flyout_Fire::$prefix_dash . 'stats-conversions-total">
						<span>' . __('Conversions', WPsite_Flyout_Fire::$text_domain) . '</span>
						<div class="' . WPsite_Flyout_Fire::$prefix_dash . 'stats-totals-text">' . number_format($conversions_total) . '</div>
						<i class="fa fa-certificate"></i>
					</div>
				</div>
				<div class="' . WPsite_Flyout_Fire::$prefix_dash . 'stats-totals col-xs-4">
					<div class="' . WPsite_Flyout_Fire::$prefix_dash . 'stats-conversion-rate-total">
						<span>' .  __('Conversion Rate', WPsite_Flyout_Fire::$text_domain) . '</span>
						<div class="' . WPsite_Flyout_Fire::$prefix_dash . 'stats-totals-text">' . $ctr . '%</div>
						<i class="fa fa-usd"></i>
					</div>
				</div>
			</div>

			<div style="clear:both"></div>

			<div class="' . WPsite_Flyout_Fire::$prefix_dash . 'line-graph-container">
				<canvas id="' . WPsite_Flyout_Fire::$prefix_dash . 'line-graph"></canvas>
			</div>

			<div class="table-responsive">
				<table class="table table-condensed table-striped sortable">

					<thead>
						<th>' . __('Date', WPsite_Flyout_Fire::$text_domain) . '</th>
						<th class="' . WPsite_Flyout_Fire::$prefix_dash . 'impressions-key"><span class="glyphicon glyphicon-certificate"></span> ' . __('Impressions', WPsite_Flyout_Fire::$text_domain) . '</th>
						<th class="' . WPsite_Flyout_Fire::$prefix_dash . 'conversions-key"><span class="glyphicon glyphicon-certificate"></span> ' . __('Conversions', WPsite_Flyout_Fire::$text_domain) . '</th>
						<th data-defaultsort="desc" class="' . WPsite_Flyout_Fire::$prefix_dash . 'conversion-rate-key"><i class="fa fa-usd"></i> ' . __('Conversion Rate', WPsite_Flyout_Fire::$text_domain) . '</th>
					</thead>';

					foreach (array_reverse($flyout_fire_stats) as $flyout_fire_stat) {

						$stats_content .= '<tr>
							<td>' . date('M j Y', strtotime($flyout_fire_stat['date'])) . '</td>
							<td>' . number_format($flyout_fire_stat['impressions']) . '</td>';

							$stats_content .= '
							<td>' . number_format($flyout_fire_stat['clicks']) . '</td>
							<td>' . ($flyout_fire_stat['impressions'] > 0 ? round(($flyout_fire_stat['clicks'] / $flyout_fire_stat['impressions']) * 100, 2) : '0') . '%</td>';


						$stats_content .= '</tr>';
					}

				$stats_content .= '</table>
			</div>';
		}

		echo json_encode(array('stats_content' => $stats_content, 'flyout_fire_stats' => $flyout_fire_stats));

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Load all emails using ajax to make back-end more responsive
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function emails_load() {

		include_once(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . 'admin/model/db.php');
		include_once(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . 'core/model/email-signups.php');

		// Get Start and End Dates

		$start_date = date(WPSITE_FLYOUT_FIRE_DATE_FORMAT, mktime(0, 0, 0, date("m")-1, date("d"), date("Y")));
		$end_date = date(WPSITE_FLYOUT_FIRE_DATE_FORMAT, strtotime(current_time('mysql')));

		$post_start_date = urldecode($_POST['start_date']);
		$post_end_date = urldecode($_POST['end_date']);

		if (isset($post_start_date) && $post_start_date != '') {
			$start_date = date(WPSITE_FLYOUT_FIRE_DATE_FORMAT, strtotime($post_start_date));
		}

		if (isset($post_end_date) && $post_end_date != '') {
			$end_date = date(WPSITE_FLYOUT_FIRE_DATE_FORMAT, strtotime($post_end_date));
		}

		// Get Emails

		global $wpdb;

		$emails = WPsite_Email_Signups_FF::getEmails($start_date, $end_date);
		$flyout_fires = $wpdb->get_results("SELECT * FROM `" . WPsite_Flyout_Fire_DB::getTableName() . "`");

		foreach ($emails as $key => $email) {
			$emails[$key]['flyout_fire_name'] = '<strong style="color:red;">DELETED</strong>';
		}

		foreach ($flyout_fires as $flyout_fire) {
			foreach ($emails as $key => $email) {
				if ($flyout_fire->id == $email['flyout_fire_id']) {
					$emails[$key] = array(
						'flyout_fire_id'	=> $email['flyout_fire_id'],
						'flyout_fire_name'	=> $flyout_fire->name,
						'date'				=> $email['date'],
						'email'				=> $email['email'],
						'first_name'		=> $email['first_name'],
						'last_name'			=> $email['last_name'],
					);
				}
			}
		}

		$emails_content = '<div class="col-xs-12" style="padding-left: 0px; padding-right: 0px;">
			<table class="table table-condensed table-striped">

				<thead>
					<th>' . __('Date', WPsite_Flyout_Fire::$text_domain) . '</th>
					<th>' . __('Flyout Name', WPsite_Flyout_Fire::$text_domain) . '</th>
					<th>' . __('Email', WPsite_Flyout_Fire::$text_domain) . '</th>
					<th>' . __('First Name', WPsite_Flyout_Fire::$text_domain) . '</th>
					<th>' . __('Last Name', WPsite_Flyout_Fire::$text_domain) . '</th>
				</thead>';

				if (count($emails) < 1) {
					$emails_content .= '<tr>
						<td>' . __('No emails yet', WPsite_Flyout_Fire::$text_domain) . '</td>
						<td></td>
						<td></td>
						<td></td>
						<td></td>
					</tr>';
				} else {
					foreach (array_reverse($emails) as $flyout_fire_email) {

						$emails_content .= '<tr>
							<td>' . $flyout_fire_email['date'] . '</td>
							<td>' . $flyout_fire_email['flyout_fire_name'] . '</td>
							<td>' . $flyout_fire_email['email'] . '</td>
							<td>' . $flyout_fire_email['first_name'] . '</td>
							<td>' . $flyout_fire_email['last_name'] . '</td>
						</tr>';

					}
				}

			$emails_content .= '</table>
		</div>';

		echo $emails_content;

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Load all emails using ajax to make back-end more responsive
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function entries_load() {

		// Includes

		include_once(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . 'admin/model/db.php');
		include_once(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . 'core/model/email-entries.php');
		require_once(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . 'admin/includes/php-pretty-datetime/PrettyDateTime.php');

		$db = new WPsite_Flyout_Fire_DB();
		$flyout_fires = $db->get_flyout_fires();

		$entries_content = '';

		// Get Start and End Dates

		$start_date = date(WPSITE_FLYOUT_FIRE_DATE_FORMAT, mktime(0, 0, 0, date("m")-1, date("d"), date("Y")));
		$end_date = date(WPSITE_FLYOUT_FIRE_DATE_FORMAT, mktime(59, 59, 23, date("m"), date("d"), date("Y")));

		$post_start_date = urldecode($_POST['start_date']);
		$post_end_date = urldecode($_POST['end_date']);

		if (isset($post_start_date) && $post_start_date != '') {
			$start_date = date(WPSITE_FLYOUT_FIRE_DATE_FORMAT, strtotime($post_start_date));
		}

		if (isset($post_end_date) && $post_end_date != '') {

			$temp_end_date = strtotime($post_end_date);

			$end_date = date(WPSITE_FLYOUT_FIRE_DATE_FORMAT, mktime(59, 59, 23, date("m", $temp_end_date), date("d", $temp_end_date), date("Y", $temp_end_date)));
		}

		// Get Entries

		global $wpdb;

		$entries = WPsite_Email_Entries_FF::getEntries($start_date, $end_date);

		foreach ($entries as $key => $email) {
			$entries[$key]['flyout_fire_name'] = '<strong style="color:red;">' . __('DELETED', WPsite_Flyout_Fire::$text_domain) . '</strong>';
		}

		foreach ($flyout_fires as $flyout_fire) {
			foreach ($entries as $key => $entry) {
				if ($flyout_fire['id'] == $entry['flyout_fire_id']) {
					$entries[$key]['flyout_fire_name'] = $flyout_fire['name'];
				}
			}
		}

		$now = new DateTime();

		if (count($entries) < 1) {
			$entries_content .= '<tr>
				<td>' . __('No entries found', WPsite_Flyout_Fire::$text_domain) . '</td>
			</tr>';
		} else {

		$entries_content = '<div class="col-xs-12" style="padding-left: 0px; padding-right: 0px;">
			<div class="col-xs-4 ' . WPsite_Flyout_Fire::$prefix_dash . 'entry-list">
				<table class="table table-condensed table-hover">';


						foreach (array_reverse($entries) as $entry) {

							if ( !isset($entry_id) ) {
								$entry_id = $entry['id'];
							}

							$dateTime = new DateTime($entry['date']);

							$message = $entry['message'];

							if ( strlen($message) > 100 ) {
								$message = substr($message, 0, 50) . ' ...';
							}

							$entries_content .= '<tr class="' . WPsite_Flyout_Fire::$prefix_dash . 'entry-row" data-entry-id="' . $entry['id'] . '">
								<td>
									<div class="col-xs-12">
										<span class="' . WPsite_Flyout_Fire::$prefix_dash . 'entry-email pull-left">' . $entry['email'] . '</span>
										<span class="' . WPsite_Flyout_Fire::$prefix_dash . 'entry-date pull-right"><em>' . PrettyDateTime::parse($dateTime, $now) . '</em></span>
									</div>
									<div class="col-xs-12">
										<span class="' . WPsite_Flyout_Fire::$prefix_dash . 'entry-subject pull-left">' . $entry['subject'] . '</span>
										<span class="' . WPsite_Flyout_Fire::$prefix_dash . 'entry-optin pull-right">' . $entry['flyout_fire_name'] . '</span>
									</div>
									<div class="col-xs-12">
										<p class="' . WPsite_Flyout_Fire::$prefix_dash . 'entry-message"><em>' . $message . '</em></p>
									</div>
								</td>
							</tr>';

						}


			$entries_content .= '
				</table>
			</div>
			<div class="col-xs-8 ' . WPsite_Flyout_Fire::$prefix_dash . 'single-entry" data-entry-id="' . $entry_id . '"></div>
		</div>';

		}

		echo $entries_content;

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get the data for a single entry
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function entry_load() {

		// Check if their is an entry id

		if ( !isset($_POST['entry_id']) ) {
			echo '';
			die();
		}

		// Get Entry Data

		global $wpdb;

		$entry = WPsite_Email_Entries_FF::getEntry($_POST['entry_id']);
		$entry = $entry[0];

		require_once(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . 'admin/includes/php-pretty-datetime/PrettyDateTime.php');

		$now = new DateTime();
		$dateTime = new DateTime($entry['date']);

		$entry_content = '<div class="' . WPsite_Flyout_Fire::$prefix_dash . 'entry-container">

			<div class="' . WPsite_Flyout_Fire::$prefix_dash . 'entry-header-data">
				<div class="' . WPsite_Flyout_Fire::$prefix_dash . 'entry-info-email">' . $entry['email'] . '<span class="' . WPsite_Flyout_Fire::$prefix_dash . 'entry-date pull-right"><em>' . PrettyDateTime::parse($dateTime, $now) . '</em></span></div>
				<div class="' . WPsite_Flyout_Fire::$prefix_dash . 'entry-info-subject">' . $entry['subject'] . '</div>
			</div>

			<p class="' . WPsite_Flyout_Fire::$prefix_dash . 'entry-info-message">' . $entry['message'] . '</p>

		</div>';

		echo $entry_content;

		die();

	}

	/**
	 * Email the weekly Flyout Stats to the admin account
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function setup_flyout_fire_email_stats() {

		$global_settings = get_option(WPsite_Flyout_Fire::$prefix . 'global_settings');

		if ( $global_settings === false ) {
			$global_settings = self::default_global_settings();
		}

		if (!$global_settings['send_weekly_email']) {
			return false;
		}

		// Comment this out for testing

		if (date('N') != 7) {
			return false;
		}

		include_once(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . 'admin/model/db.php');

		global $wpdb;

		$admins = get_users('role=administrator');

		$start_date = date(WPSITE_FLYOUT_FIRE_DATE_FORMAT, mktime(0, 0, 0, date("m"), date("d")-7, date("Y")));
		$end_date = date(WPSITE_FLYOUT_FIRE_DATE_FORMAT, strtotime(current_time('mysql')));

		$stats = WPsite_Stats_FF::getStats($start_date, $end_date);
		$flyout_fires = $wpdb->get_results("SELECT * FROM `" . WPsite_Flyout_Fire_DB::getTableName() . "`");
		$flyout_fire_stats = array();

		foreach ($flyout_fires as $flyout_fire) {
			foreach ($stats as $stat) {
				if ($flyout_fire->id == $stat['flyout_fire_id']) {
					$flyout_fire_stats[$flyout_fire->id] = array(
						'flyout_fire_id'	=> $stat['flyout_fire_id'],
						'flyout_fire_name'	=> $flyout_fire->name,
						'flyout_fire_type'	=> $flyout_fire->template,
						'date'			=> $stat['date'],
						'impressions'	=> isset($flyout_fire_stats[$flyout_fire->id]['impressions']) ? $flyout_fire_stats[$flyout_fire->id]['impressions'] + $stat['impressions'] : $stat['impressions'],
						'clicks'	=> isset($flyout_fire_stats[$flyout_fire->id]['clicks']) ? $flyout_fire_stats[$flyout_fire->id]['clicks'] + $stat['clicks'] : $stat['clicks'],
					);
				}
			}
		}

		$impressions_total = 0;
		$conversions_total = 0;
		foreach ($flyout_fire_stats as $flyout_fire_stat) {
		    $impressions_total += $flyout_fire_stat['impressions'];
		    $conversions_total += $flyout_fire_stat['clicks'];
		}

		$site_url = get_site_url();

		foreach ( $admins as $admin ) {

			$subject = __('Weekly Flyout Fire Stats by 99robots - ' . $site_url, WPsite_Flyout_Fire::$text_domain);

			$head = '<html>
				<head></head>';

			$body = '<body>

					<img src="' . WPSITE_FLYOUT_FIRE_PLUGIN_URL . '/img/rainbow-strip-hz-wide.png" style="width: 100%;"/>

					<h1>' . __('Flyout Fire Weekly Stats', WPsite_Flyout_Fire::$text_domain) . '</h1>
					<h1>' . __('Site: ', WPsite_Flyout_Fire::$text_domain) . $site_url . '</h1>
					<h1>' . __('Period: ', WPsite_Flyout_Fire::$text_domain) . date('M j', strtotime($start_date)) . ' - ' . date('M j', strtotime($end_date)) . '</h1>

					<div style="min-height: 20px;
					  padding: 19px;
					  margin-bottom: 20px;
					  background-color: #f5f5f5;
					  border: 1px solid #e3e3e3;
					  border-radius: 4px;
					  -webkit-box-shadow: inset 0 1px 1px rgba(0, 0, 0, .05);
					          box-shadow: inset 0 1px 1px rgba(0, 0, 0, .05);">

						<table style="width:100%; border: none;">

							<col width="33.33%">
							<col width="33.33%">
							<col width="33.33%">

							<thead style="border: none;">
								<th style="border: none;">' . __('Impressions', WPsite_Flyout_Fire::$text_domain) . '</th>
								<th style="border: none;">' . __('Clicks', WPsite_Flyout_Fire::$text_domain) . '</th>
								<th style="border: none;">' .  __('Click-Through Rate', WPsite_Flyout_Fire::$text_domain) . '</th>
							</thead>

							<tr style="border: none;">
								<td style="border: none; background: transparent; text-align: center; font-size: 60px;">' . number_format($impressions_total) . '</td>
								<td style="border: none; background: transparent; text-align: center; font-size: 60px;">' . number_format($conversions_total) . '</td>
								<td style="border: none; background: transparent; text-align: center; font-size: 60px;">' . round(($conversions_total/$impressions_total) * 100,2) . '%</td>
							</tr>
						</table>

					</div>
					<table style="width: 100%;
					max-width: 100%;
					margin-bottom: 20px;">

						<thead style="border: 1px solid #ddd;">
							<th style="vertical-align: bottom;
								border-bottom: 2px solid #ddd;padding: 8px;
								line-height: 1.42857143;
								vertical-align: top;">' . __('Flyout', WPsite_Flyout_Fire::$text_domain) . '</th>
							<th style="vertical-align: bottom;
								border-bottom: 2px solid #ddd;padding: 8px;
								line-height: 1.42857143;
								vertical-align: top;">' . __('Impressions', WPsite_Flyout_Fire::$text_domain) . '</th>
							<th style="vertical-align: bottom;
								border-bottom: 2px solid #ddd;padding: 8px;
								line-height: 1.42857143;
								vertical-align: top;">' . __('Clicks', WPsite_Flyout_Fire::$text_domain) . '</th>
							<th style="vertical-align: bottom;
								border-bottom: 2px solid #ddd;padding: 8px;
								line-height: 1.42857143;
								vertical-align: top;">' . __('Click-Through-Rate', WPsite_Flyout_Fire::$text_domain) . '</th>
						</thead>';

						foreach ($flyout_fire_stats as $flyout_fire_stat) {

							$body .= '<tr style="border: 1px solid #ddd;text-align:center;">
								<td>
									<a style="
								  color: white;
								  text-decoration: none;
								  color: #fff;
								  cursor: pointer;
								display: inline-block;
								font-family: \'Helvetica Neue\', Helvetica, Arial, sans-serif;
								font-size: 12px;
								font-stretch: normal;
								font-style: normal;
								font-variant: normal;
								font-weight: normal;
								height: 18px;
								letter-spacing: normal;
								line-height: 18px;
								margin-bottom: 0px;
								margin-left: 0px;
								margin-right: 0px;
								margin-top: 0px;
								overflow-x: visible;
								overflow-y: visible;
								padding-bottom: 1px;
								padding-left: 5px;
								padding-right: 5px;
								padding-top: 1px;
								  background-color: #337ab7;
								  border-color: #2e6da4;
								  -webkit-border-radius: 3px;
								  -moz-border-radius: 3px;
								  border-radius: 3px;" href="' . admin_url() . 'admin.php?page=' . WPsite_Flyout_Fire::$stats_page . '&flyout_fire_id=' . $flyout_fire_stat['flyout_fire_id'] . '&flyout_fire_name=' . $flyout_fire_stat['flyout_fire_name'] . '" role="button" style="color: white; text-decoration: none;">
										' .  $flyout_fire_stat['flyout_fire_name'] . '
									</a>
								</td>
								<td>' . number_format($flyout_fire_stat['impressions']) . '</td>';


								$body .= '
								<td>' . number_format($flyout_fire_stat['clicks']) . '</td>
								<td>' . ($flyout_fire_stat['impressions'] > 0 ? round(($flyout_fire_stat['clicks'] / $flyout_fire_stat['impressions']) * 100, 2) : '0') . '%</td>';


							$body .= '</tr>';
						}

				$body .= '</table>
				</body>';

			$foot = '
				<br/>
				<br/>
				<br/>
				<p style="text-align: center;"><a href="http://wpsite.net">' . __('Visit', WPsite_Flyout_Fire::$text_domain) . '</a> ' . __('our site to read about all the latest WordPress News.', WPsite_Flyout_Fire::$text_domain) . '</p>
			</html>';

			$message = $head . $body . $foot;
			//$headers[] = 'From: charlie@99robots.com';
			$headers[] = 'Content-Type: text/html; charset=UTF-8';

			$result = wp_mail($admin->user_email, $subject, $message, $headers);
		}
	}

	/**
	 * Save the send weekly email setting
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function send_weekly_email() {

		$global_settings = get_option(WPsite_Flyout_Fire::$prefix . 'global_settings');

		if ( $global_settings === false ) {
			$global_settings = self::default_global_settings();
		}

		if ($_POST['send_weekly_email'] == 'true') {
			$global_settings['send_weekly_email'] = true;
		} else {
			$global_settings['send_weekly_email'] = false;
		}

		update_option(WPsite_Flyout_Fire::$prefix . 'global_settings', $global_settings);

		echo '';
		die();
	}

	/**
	 * Get all MailChimp Lists and display in settings
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_mailchimp_lists() {

		$options = '';

		if (isset($_POST['api_key']) && $_POST['api_key'] != '') {
			require_once(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . 'core/includes/mailchimp/MailChimp.php');

			$MailChimp = new WPS_MailChimp($_POST['api_key']);
			$lists = $MailChimp->call('lists/list');

			if (isset($lists) && is_array($lists)) {

				foreach ($lists['data'] as $list) {
					$options .= '<option value="' . $list['id'] . '">' .  $list['name'] . '</option>';
				}

				if (isset($_POST['list']) && $_POST['list'] != '') {
					$options = '';
					foreach ($lists['data'] as $list) {

						if ($_POST['list'] == $list['id']) {
							$options .= '<option value="' . $list['id'] . '" selected="selected">' .  $list['name']. '</option>';
						} else {
							$options .= '<option value="' . $list['id'] . '">' .  $list['name'] . '</option>';
						}
					}
				}
			}
		}

		echo $options;

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get the Aweber lists for an account
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_aweber_lists() {

		$options = '';
		$consumerKey = '';
		$consumerSecret = '';
		$accessKey = '';
		$accessSecret = '';

		if (isset($_POST['code']) && $_POST['code'] != '') {

			require(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . 'core/includes/aweber/aweber_api.php');
			include_once(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . 'admin/model/db.php');

			try {
				$credentials = AWeberAPI::getDataFromAweberID($_POST['code']);
				list($consumerKey, $consumerSecret, $accessKey, $accessSecret) = $credentials;


				$consumerKey = isset($consumerKey) && !empty($consumerKey) ? $consumerKey : '';
				$consumerSecret = isset($consumerSecret) && !empty($consumerSecret) ? $consumerSecret : '';
				$accessKey = isset($accessKey) && !empty($accessKey) ? $accessKey : '';
				$accessSecret = isset($accessSecret) && !empty($accessSecret) ? $accessSecret : '';
			} catch (AWeberAPIException $exc) {
				error_log($exc);
			}

			try {

				$aweber = new AWeberAPI($consumerKey, $consumerSecret);
				$account = $aweber->getAccount($accessKey, $accessSecret);
				$lists = $account->loadFromUrl('/accounts/' . $account->id . '/lists/');

				foreach ($lists as $list) {
					$options .= '<option value="' . $list->id . '">' .  $list->name . '</option>';
				}

			} catch (AWeberAPIException $exc) { error_log($exc); }
		}

		if (isset($_POST['list']) && $_POST['list'] != '') {

			$consumerKey     = $_POST['consumer_key'];
			$consumerSecret  = $_POST['consumer_secret'];
			$accessKey       = $_POST['access_key'];
			$accessSecret    = $_POST['access_secret'];

			require(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . 'core/includes/aweber/aweber_api.php');
			include_once(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . 'admin/model/db.php');

			try {

				$aweber = new AWeberAPI($consumerKey, $consumerSecret);
				$account = $aweber->getAccount($accessKey, $accessSecret);
				$lists = $account->loadFromUrl('/accounts/' . $account->id . '/lists/');

				$options = '';
				foreach ($lists as $list) {
					if ($_POST['list'] == $list->id) {
						$options .= '<option value="' . $list->id . '" selected="selected">' .  $list->name . '</option>';
					} else {
						$options .= '<option value="' . $list->id . '">' .  $list->name . '</option>';
					}
				}

			} catch (AWeberAPIException $exc) { error_log($exc); }
		}

		echo json_encode(array(
			'html'               => $options,
			'consumer_key'       => $consumerKey,
			'consumer_secret'    => $consumerSecret,
			'access_key'         => $accessKey,
			'access_secret'      => $accessSecret,
		));

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all Get Repsonse Lists and display in settings
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_getresponse_lists() {

		$options = '';

		if (isset($_POST['api_key']) && $_POST['api_key'] != '') {

			require(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . 'core/includes/getresponse/jsonRPCClient.php');
			$api = new jsonRPCClient('http://api2.getresponse.com');

			try {
				$result = $api->get_campaigns($_POST['api_key']);
				foreach ((array) $result as $k => $v) {
					$campaigns[] = array('id' => $k, 'name' => $v['name']);
				}
			}

			catch (Exception $e) {}

			if (isset($campaigns) && is_array($campaigns)) {

				foreach ($campaigns as $campaign) {
					$options .= '<option value="' . $campaign['id'] . '">' .  $campaign['name'] . '</option>';
				}

				if (isset($_POST['campaign']) && $_POST['campaign'] != '') {
					$options = '';
					foreach ($campaigns as $campaign) {

						if ($_POST['campaign'] == $campaign['id']) {
							$options .= '<option value="' . $campaign['id'] . '" selected="selected">' .  $campaign['name'] . '</option>';
						} else {
							$options .= '<option value="' . $campaign['id'] . '">' .  $campaign['name'] . '</option>';
						}
					}
				}
			}
		}

		echo $options;

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all Campaign Monitor Lists and display in settings
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_campaignmonitor_lists() {

		$lists = '';
		$clients = '';

		if (isset($_POST['api_key']) && $_POST['api_key'] != '') {

			require(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . 'core/includes/campaignmonitor/csrest_general.php');
			require(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . 'core/includes/campaignmonitor/csrest_clients.php');
			$auth = array('api_key' => $_POST['api_key']);
			$wrap = new CS_REST_General($auth);
			$result = $wrap->get_clients();


			if ($result->was_successful()) {

				foreach ($result->response as $client) {
					$clients .= '<option value="' . $client->ClientID . '">' .  $client->Name . '</option>';
				}

				if (isset($_POST['client']) && $_POST['client'] != '') {
					$clients = '';
					foreach ($result->response as $client) {
						if ($_POST['client'] == $client->ClientID) {
							$clients .= '<option value="' . $client->ClientID . '" selected="selected">' .  $client->Name . '</option>';
						} else {
							$clients .= '<option value="' . $client->ClientID . '">' .  $client->Name . '</option>';
						}
					}
				}

				if (isset($_POST['client']) && $_POST['client'] != '') {
					$client_id = $_POST['client'];
				} else {
					$client_id = $result->response[0]->ClientID;
				}

				$wrap = new CS_REST_Clients($client_id, $_POST['api_key']);
				$result = $wrap->get_lists();

				if ($result->was_successful()) {
					foreach ($result->response as $list) {
						$lists .= '<option value="' . $list->ListID . '">' .  $list->Name . '</option>';
					}

					if (isset($_POST['list']) && $_POST['list'] != '') {
						$lists = '';
						foreach ($result->response as $list) {
							if ($_POST['list'] == $list->ListID) {
								$lists .= '<option value="' . $list->ListID . '" selected="selected">' .  $list->Name . '</option>';
							} else {
								$lists .= '<option value="' . $list->ListID . '">' .  $list->Name . '</option>';
							}
						}
					}
				}
			}
		}

		echo json_encode(array('clients' => $clients, 'lists' => $lists));

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Update all Campaign Monitor Lists and display in settings
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function update_campaignmonitor_lists() {

		$lists = '';

		if (isset($_POST['api_key']) && $_POST['api_key'] != '' &&
			isset($_POST['client_id']) && $_POST['client_id'] != '') {

			require(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . 'core/includes/campaignmonitor/csrest_general.php');
			require(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . 'core/includes/campaignmonitor/csrest_clients.php');


			$wrap = new CS_REST_Clients($_POST['client_id'], $_POST['api_key']);
			$result = $wrap->get_lists();


			if ($result->was_successful()) {
				foreach ($result->response as $list) {
					$lists .= '<option value="' . $list->ListID . '">' .  $list->Name . '</option>';
				}
			}
		}

		echo $lists;

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all Mad Mimi Lists and display in settings
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_madmimi_lists() {

		$options = '';

		if (isset($_POST['api_key']) && $_POST['api_key'] != '' &&
			isset($_POST['username']) && $_POST['username'] != '') {

			require(WPSITE_FLYOUT_FIRE_PLUGIN_DIR . 'core/includes/madmimi/MadMimi.class.php');

			$mailer = new MadMimi($_POST['username'], $_POST['api_key']);

			if (isset($mailer)) {
				try {
					$lists = $mailer->Lists();
					$lists  = new SimpleXMLElement($lists);

				    if ($lists->list) {
						foreach ($lists->list as $l) {
							$options .= '<option value="' . $l->attributes()->{'name'}->{0} . '">' .  $l->attributes()->{'name'}->{0} . '</option>';
						}
				    }

				    if (isset($_POST['list']) && $_POST['list'] != '') {
					    $options = '';
						foreach ($lists->list as $l) {

							if ($_POST['list'] == $l->attributes()->{'name'}->{0}) {
								$options .= '<option value="' . $l->attributes()->{'name'}->{0} . '" selected="selected">' .  $l->attributes()->{'name'}->{0} . '</option>';
							} else {
								$options .= '<option value="' . $l->attributes()->{'name'}->{0} . '">' .  $l->attributes()->{'name'}->{0} . '</option>';
							}
						}
					}
				} catch (Exception $exc) {}
			}
		}

		echo $options;

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all the infusionsoft lists for specfic account
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_infusionsoft_lists() {

		if ( ! function_exists( 'curl_init' ) ) {
			return __( 'curl_init is not defined ', WPsite_Flyout_Fire::$text_domain);
		}

		if ( ! class_exists( 'iSDK' ) ) {
			require_once( WPSITE_FLYOUT_FIRE_PLUGIN_DIR . 'core/includes/infusionsoft/isdk.php' );
		}

		$options = '';

		// Make sure the use entered in the api key

		if (isset($_POST['app_id']) && $_POST['app_id'] != '' &&
			isset($_POST['api_key']) && $_POST['api_key'] != '') {

			try {
				$infusion_app = new iSDK();
				$infusion_app->cfgCon( $_POST['app_id'], $_POST['api_key'], 'throw' );
			} catch( iSDKException $e ){
				$error_message = $e->getMessage();
			}

			if ( empty( $error_message ) ) {
				$need_request = true;
				$page = 0;
				$all_lists = array();

				while ( true == $need_request ) {
					$error_message = 'success';
					$lists_data = $infusion_app->dsQuery( 'ContactGroup', 1000, $page, array( 'Id' => '%' ), array( 'Id', 'GroupName' ) );
					$all_lists = array_merge( $all_lists, $lists_data );

					if ( 1000 > count( $lists_data ) ) {
						$need_request = false;
					} else {
						$page++;
					}
				}
			}

			// Get all list information

			if ( ! empty( $all_lists ) ) {
				foreach( $all_lists as $list ) {

					if ($_POST['list'] == $list['Id']) {
						$options .= '<option value="' . $list['Id'] . '" selected="selected">' .  $list['GroupName'] . '</option>';
					} else {
						$options .= '<option value="' . $list['Id'] . '">' .  $list['GroupName'] . '</option>';
					}
				}
			}
		}

		echo $options;

		die(); // this is required to terminate immediately and return a proper response

	}

	/**
	 * Get all the MyMail lists
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_mymail_lists() {

		if ( !function_exists('mymail') ) {
			echo '';
			die();
		}

		$lists = mymail('lists')->get();
		$options = '';

		foreach ( $lists as $list ) {
			if ($_POST['list'] == $list->ID) {
				$options .= '<option value="' . $list->ID . '" selected="selected">' .  $list->name . '</option>';
			} else {
				$options .= '<option value="' . $list->ID . '">' .  $list->name . '</option>';
			}
		}

		echo $options;
		die();
	}

	/**
	 * Get all the Active Campaign lists
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_activecampaign_lists() {

		require_once( WPSITE_FLYOUT_FIRE_PLUGIN_DIR . 'core/includes/activecampaign/ActiveCampaign.class.php' );

		$options = '';

		if ( isset($_POST['app_url']) && $_POST['app_url'] != '' &&
			isset($_POST['api_key']) && $_POST['api_key'] != '' ) {

			$ac = new ActiveCampaign($_POST['app_url'], $_POST['api_key']);

			if ( !(int)$ac->credentials_test() ) {

				echo "";
				exit();
			}

			$lists = $ac->api("list/list?ids=all");

			foreach ( $lists as $list ) {

				if ( !isset($list->id) || empty($list->id) ) {
					continue;
				}

				if ($_POST['list'] == $list->id) {
					$options .= '<option value="' . $list->id . '" selected="selected">' .  $list->name . '</option>';
				} else {
					$options .= '<option value="' . $list->id . '">' .  $list->name . '</option>';
				}
			}
		}

		echo $options;
		die();
	}

	/**
	 * Get all Posts in post type
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_posts() {

		echo json_encode(get_posts('posts_per_page=-1&post_type=' . $_POST['post_type']));

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all Categories
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_categories() {

		echo json_encode(get_categories());

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Get all Tags
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_tags() {

		echo json_encode(get_tags());

		die(); // this is required to terminate immediately and return a proper response
	}

	/**
	 * Everyday check if there is a record for impressions or clicks for each fireabr.
	 * If there is no record than add one and set it to 0..
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function initialize_flyout_fire_stats_daily() {
		WPsite_Stats_FF::initialize_flyout_fire_stats();
	}

	/**
	 * Mulit-byte Unserialize
	 *
	 * UTF-8 will screw up a serialized string
	 *
	 * @access private
	 * @param string
	 * @return string
	 */
	static function mb_unserialize($string) {
	    $string2 = preg_replace_callback(
	        '!s:(\d+):"(.*?)";!s',
	        function($m){
	            $len = strlen($m[2]);
	            $result = "s:$len:\"{$m[2]}\";";
	            return $result;

	        },
	        $string);
	    return unserialize($string2);
	}

}
//endif;