/**
 *
 * Created by Kyle Benk kjbenk@gmail.com
 *
 * 12/14
 */

jQuery(document).ready(function($) {

	// Load all entries

	$.post(ajaxurl, {
		'action': 'wps_ff_entries_load',
		'start_date' : getQuerystring(wps_ff_entries_data.prefix_dash + 'start-date'),
		'end_date' : getQuerystring(wps_ff_entries_data.prefix_dash + 'end-date'),
		'entry_id' : getQuerystring('entry_id', false),
		'flyout_id' : getQuerystring('flyout_id', false)}, function(response) {

			$("#" + wps_ff_entries_data.prefix_dash + "loading-entries").remove();
			$(response).insertAfter("#" + wps_ff_entries_data.prefix_dash + "before-table");

			if (getQuerystring('entry_id', false)) {
				$("#" + wps_ff_entries_data.prefix_dash + "before-table").remove();
			}

			get_single_entry_data($('.' + wps_ff_entries_data.prefix_dash + 'single-entry').data('entry-id'));
	});

	// Load entry data on click

	$(document).on('click', '.' + wps_ff_entries_data.prefix_dash + 'entry-row', function(){
		get_single_entry_data($(this).closest('tr').data('entry-id'));
	});

	// Date Pickers

	if ($('#' + wps_ff_entries_data.prefix_dash + 'start-datepicker').length != 0 && $('#' + wps_ff_entries_data.prefix_dash + 'end-datepicker').length != 0) {

		$('#' + wps_ff_entries_data.prefix_dash + 'start-datepicker').datetimepicker({
	        format: 'MM/DD/YYYY'
	    });

		$('#' + wps_ff_entries_data.prefix_dash + 'end-datepicker').datetimepicker({
	        format: 'MM/DD/YYYY'
	    });

		$('#' + wps_ff_entries_data.prefix_dash + 'end-datepicker')
			.data("DateTimePicker")
			.maxDate( moment(wps_ff_entries_data.today, "M/D/Y") );

		$('#' + wps_ff_entries_data.prefix_dash + 'start-datepicker')
			.data("DateTimePicker")
			.maxDate( moment(wps_ff_entries_data.today, "M/D/Y") );

		$('#' + wps_ff_entries_data.prefix_dash + 'end-datepicker')
			.data("DateTimePicker")
			.minDate( $('#' + wps_ff_entries_data.prefix_dash + 'start-datepicker').data("DateTimePicker").date() );

		$('#' + wps_ff_entries_data.prefix_dash + 'start-datepicker').on("dp.change",function (e) {
	       $('#' + wps_ff_entries_data.prefix_dash + 'end-datepicker').data("DateTimePicker").minDate(e.date);
	    });

	    $('#' + wps_ff_entries_data.prefix_dash + 'end-datepicker').on("dp.change",function (e) {
	       $('#' + wps_ff_entries_data.prefix_dash + 'start-datepicker').data("DateTimePicker").maxDate(e.date);
	    });

	}

	/**
	 * Get entry data
	 *
	 * @access public
	 * @param mixed entry_id
	 * @return void
	 */
	function get_single_entry_data(entry_id) {

		$('.' + wps_ff_entries_data.prefix_dash + 'entry-row').removeClass('active');
		$('.' + wps_ff_entries_data.prefix_dash + 'entry-row[data-entry-id="' + entry_id + '"]').addClass('active');

		$('.' + wps_ff_entries_data.prefix_dash + 'single-entry').html('<div id="<?php echo self::$prefix_dash; ?>loading-stats"><div class="fa fa-spinner fa-spin"></div></div>');

		// Load single entry

		$.post(ajaxurl, {
			'action': 'wps_ff_entry_load',
			'entry_id' : entry_id}, function(response) {

				$('.' + wps_ff_entries_data.prefix_dash + 'single-entry').html(response);

		});
	}

	/**
     * Get the http parameters
     *
     * @access public
     * @param mixed key
     * @param mixed default_
     * @return void
     */
    function getQuerystring(key, default_) {
	  if (default_==null) default_="";
	  key = key.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");
	  var regex = new RegExp("[\\?&]"+key+"=([^&#]*)");
	  var qs = regex.exec(window.location.href);
	  if(qs == null)
	    return default_;
	  else
	    return qs[1];
	}
});